program cht;

type
		PointPtr=^TPoint;
		TPoint=record
			X:integer;
			Y:integer;
			C,H,N,O,P,S,Si,Br,Cl,F,I,Na,K:integer;
			RecCount:integer;
			Last:PointPtr;
		end;
				 
var C,H,N,O,P,S,Si,Br,Cl,F,I,Na,K,X1,X2,Y1,Y2,T:Integer;
		IFile:text;
		Point,Last,Current:PointPtr;
		sss:string;
		A:string[6];
		M:real;
		Count,code,atoms,rep:integer;
		Abandon,debug,verbose,exact:boolean;
		
begin
	If (Paramcount=0) then
		begin
			Writeln('enter "cht -h" for help');
			Halt(0);
		end;
	C:=0;
	H:=0;
	N:=0;
	O:=0;
	P:=0;
	S:=0;Si:=0;Br:=0;I:=0;Cl:=0;F:=0;Na:=0;K:=0;
	verbose:=false;
	debug:=false;
	exact:=false;
	Count:=0;
	For rep:= 1 to Paramcount do
		begin
			If (Paramstr(rep)='-v') OR (Paramstr(rep)='--verbose') then verbose:=true;
			If (Paramstr(rep)='-d') OR (Paramstr(rep)='--debug') then debug:=true;
			If (Paramstr(rep)='-e') OR (Paramstr(rep)='--exact') then exact:=true;
			If (Paramstr(rep)='-h') OR (Paramstr(rep)='--help') then 
				begin
					Writeln('The Chemtool drawings analyzer 0.11');
      		Writeln('***   Gizmo Head Software   ***');
      		Writeln('    Radek Liboska (c) 2000');
					Writeln;
					Writeln('syntax: cht [-options] <filename.cht>');
					Writeln;
					Writeln('Recognize C,H,O,N,P(V),S(VI),Si,Br,I,Cl,F,Na,K');
					Writeln('          CH,HC,CH_2,H_2C,CH3,H_3C,OH,HO,SH,HS,NH,HN,NH_2,H_2N,CN,CN,N_3,CH_2OH,CH_3O,OCH_3');
					Writeln('          Me,Et,Pr,Bu,iPr,tBu,Ph,Ac,Bz,Bn,Tr,DMTr,Ts,Ms,TMS,TBDMS,TBDPS');
					Writeln('          OMe,OEt,OPr,OBu,OiPr,OtBu,OAc,OBz,OBn,OTr,ODMTr,OTs,OMs,OTMS,OTBDMS,OTBDPS');
					Writeln('          MeO,EtO,PrO,BuO,iPrO,tBuO,AcO,BzO,BnO,TrO,DMTrO,TsO,MsO,TMSO,TBDMSO,TBDPSO');
					Writeln;
					Writeln('options:');
					Writeln('  -h or --help : this help');
					Writeln('  -e or --exact: calculate exact mass for MS');
					Writeln('  -v or --verbose : be verbose');
					Writeln('  -d or --debug : be more verbose');
					Writeln;
					Halt(0);
				end;
			If Paramstr(rep)[1]<>'-' then Assign(IFile,Paramstr(rep));
		end;
	Reset(IFile);
	New(Point);
	Point^.X:=0;
	Point^.Y:=0;
	Point^.C:=0;
	Point^.H:=0;
	Point^.N:=0;
	Point^.O:=0;
	Point^.P:=0;
	Point^.S:=0;
	Point^.Si:=0;
	Point^.Br:=0;
	Point^.Cl:=0;
	Point^.F:=0;
	Point^.I:=0;
	Point^.Na:=0;
	Point^.K:=0;
	Point^.RecCount:=Count;
	Point^.Last:=nil;
{	New(Point);
	Readln(IFile); error herrited from previous versions}
	Readln(IFile);
	Readln(IFile);
	Readln(IFile);
	Readln(IFile,sss);
	Repeat
		if debug then Writeln(sss);
		Val(Copy(sss,1,Pos(#09,sss)-1),X1,code);
		sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		Val(Copy(sss,1,Pos(#09,sss)-1),Y1,code);
		sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		Val(Copy(sss,1,Pos(#09,sss)-1),X2,code);
		sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		Val(Copy(sss,1,Pos(#09,sss)-1),Y2,code);
		sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
		Val(Copy(sss,1,Length(sss)),T,code);
	 
		Abandon:=false;
		Current:=Point;
		While Point^.Last<>nil  do
			begin
				If (Point^.X=X1) AND (Point^.Y=Y1) then
					begin
						if debug then Writeln('  ',Point^.RecCount,' --> Joined at ',X1,' ',Y1);
						If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=Point^.H-1;
						If (T=1) OR (T=2) OR (T=4) then Point^.H:=Point^.H-2;
						If (T=3) then Point^.H:=Point^.H-3;
						Abandon:=true;
					end;
				Point:=Point^.Last;
		  end;
		Point:=Current;

		If Not Abandon then
			begin
				Inc(Count);
				Last:=Point;	
				New(Point);
				Point^.X:=X1;
				if debug then Write(' Point^.X: ',Point^.X);
				Point^.Y:=Y1;
				if debug then Write(' Point^.Y: ',Point^.Y);
				Point^.C:=1;
				if debug then Write(' Point^.C: ',Point^.C);
				If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=3;
				If (T=1) OR (T=2) OR (T=4) then Point^.H:=2;
				If (T=3) then Point^.H:=1;
				if debug then Write(' Point^.H: ',Point^.H);
				Point^.N:=0;
				Point^.O:=0;
				Point^.P:=0;
				Point^.S:=0;
				Point^.Si:=0;
				Point^.Br:=0;
				Point^.Cl:=0;
				Point^.F:=0;
				Point^.I:=0;
				Point^.Na:=0;
				Point^.K:=0;
				Point^.RecCount:=Count;
				if debug then Writeln('Point^.RecCount: ',Point^.RecCount);
				Point^.Last:=Last;
			end;

		Abandon:=false;
		Current:=Point;
		While Point^.Last<>nil  do
			begin
				If (Point^.X=X2) AND (Point^.Y=Y2) then 
					begin
						if debug then Writeln('  ',Point^.RecCount,' --> Joined at ',X2,' ',Y2);
						If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=Point^.H-1;
						If (T=1) OR (T=2) OR (T=4) then Point^.H:=Point^.H-2;
						If (T=3) then Point^.H:=Point^.H-3;
						Abandon:=true;
					end;
				Point:=Point^.Last;
		  end;
		Point:=Current;
		
		If Not Abandon then
			begin
				Inc(Count);
				Last:=Point;	
				New(Point);
				Point^.X:=X2;
				if debug then Write(' Point^.X: ',Point^.X);
				Point^.Y:=Y2;
				if debug then Write(' Point^.Y: ',Point^.Y);
				Point^.C:=1;
				if debug then Write(' Point^.C: ',Point^.C);
				If (T=0) OR (T=5) OR (T=6) OR (T=7) OR (T=10) then Point^.H:=3;
				If (T=1) OR (T=2) OR (T=4) then Point^.H:=2;
				If (T=3) then Point^.H:=1;
				if debug then Write(' Point^.H: ',Point^.H);
				Point^.N:=0;
				Point^.O:=0;
				Point^.P:=0;
				Point^.S:=0;
				Point^.Si:=0;
				Point^.Br:=0;
				Point^.Cl:=0;
				Point^.F:=0;
				Point^.I:=0;
				Point^.Na:=0;
				Point^.K:=0;
				Point^.RecCount:=Count;
				if debug then Writeln('Point^.RecCount: ',Point^.RecCount);
				Point^.Last:=Last;
			end;

		Readln(IFile,sss);
	Until NOT (sss[1] IN ['0'..'9']);

	If debug then Writeln('---- and now parse the labels ---------');
	If Copy(sss,1,Pos(' ',sss)-1)='atoms' then
		begin
			Val(Copy(sss,Pos(' ',sss),Length(sss)-Pos(' ',sss)+1),atoms,code);
			If verbose then Writeln ('HeteroAtoms: ',atoms);	
		end;
	For rep:= 1 to atoms do
		begin
			Readln(IFile,sss);
			Val(Copy(sss,1,Pos(#09,sss)-1),X1,code);
			sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
			Val(Copy(sss,1,Pos(#09,sss)-1),Y1,code);
			sss:=Copy(sss,Pos(#09,sss)+1,Length(sss)-Pos(#09,sss)+1);
			A:=Copy(sss,1,Pos(#09,sss)-1);
			
			If debug then Writeln('Atom ',A, ' X=',X1,' Y=',Y1,' sss: ',sss);		
			Current:=Point;
			While Point^.Last<>nil  do
				begin
					If (Point^.X=X1) AND (Point^.Y=Y1) then
						begin
							If debug then Writeln('  ',Point^.RecCount,' --> Heteroatom ',X1,' ',Y1);

				If A='C' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='CH' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='HC' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='CH_2' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='H_2C' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='CH_3' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='H_3C' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
								end
				else			If A='H' then
								begin
									Point^.H:=Point^.H-2;
									Point^.C:=Point^.C-1;
								end
				else				If A='O' then
								begin
									Point^.H:=Point^.H-2;
									Point^.C:=Point^.C-1;
									Point^.O:=1;
								end
				else			If A='OH' then
								begin
									Point^.H:=Point^.H-2;
									Point^.C:=Point^.C-1;
									Point^.O:=1;
								end
				else			If A='HO' then
								begin
									Point^.H:=Point^.H-2;
									Point^.C:=Point^.C-1;
									Point^.O:=1;
								end
				else			If A='CH_2OH' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
									Point^.O:=Point^.O+1;
								end
				else			If A='CH_3O' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
									Point^.O:=Point^.O+1;
								end
				else			If A='H_3CO' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
									Point^.O:=Point^.O+1;
								end
				else			If A='OCH_3' then
								begin
									Point^.H:=Point^.H;
									Point^.C:=Point^.C;
									Point^.O:=Point^.O+1;
								end
				else			If A='N' then
								begin
									Point^.H:=Point^.H-1;
									Point^.C:=Point^.C-1;
									Point^.N:=1;
								end
				else			If A='NH' then
								begin
									Point^.H:=Point^.H-1;
									Point^.C:=Point^.C-1;
									Point^.N:=1;
								end
				else			If A='HN' then
								begin
									Point^.H:=Point^.H-1;
									Point^.C:=Point^.C-1;
									Point^.N:=1;
								end
				else			If A='NH_2' then
								begin
									Point^.H:=Point^.H-1;
									Point^.C:=Point^.C-1;
									Point^.N:=1;
								end
				else			If A='H_2N' then
								begin
									Point^.H:=Point^.H-1;
									Point^.C:=Point^.C-1;
									Point^.N:=1;
								end
				else			If A='CN' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C;
									Point^.N:=1;
								end
				else			If A='NC' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C;
									Point^.N:=1;
								end
				else			If A='N_3' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.N:=3;
								end
				else			If A='P' then
								begin
									 Point^.H:=Point^.H+1;
									 Point^.C:=Point^.C-1;
									 Point^.P:=1;
								end
				else			If A='S' then  {S(VI)}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C-1;
									Point^.S:=1;
								end
				else			If A='SH' then  {S(II)}
								begin
									Point^.H:=Point^.H-2;
									Point^.C:=Point^.C-1;
									Point^.S:=1;
								end
				else			If A='HS' then  {S(II)}
								begin
									Point^.H:=Point^.H-2;
									Point^.C:=Point^.C-1;
									Point^.S:=1;
								end
				else			If A='Si' then
								begin
									Point^.C:=Point^.C-1;
									Point^.Si:=1;
								end
				else			If A='Br' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.Br:=1;
								end
				else			If A='I' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.I:=1;
								end
				else			If A='Cl' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.Cl:=1;
								end
				else			If A='F' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.F:=1;
								end
				else			If A='Na' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.Na:=1;
								end
				else			If A='K' then
								begin
									Point^.H:=Point^.H-3;
									Point^.C:=Point^.C-1;
									Point^.K:=1;
								end
				else			If A='Bz' then {Benzoyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+1;
								end
				else			If A='Ac' then {Acetyl}
								begin
									Point^.C:=Point^.C+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='Me' then {Methyl}
								begin
									Point^.H:=Point^.H+0;
									Point^.C:=Point^.C+0;
								end
				else			If A='Et' then {Ethyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+1;
								end
				else			If A='Pr' then {Propyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+2;
								end
				else			If A='Bu' then {Butyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+3;
								end
				else			If A='iPr' then {2-Propyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+2;
								end
				else			If A='tBu' then {t-Butyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+3;
								end
				else			If A='Ph' then {Phenyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+5;
								end
				else			If A='Bn' then {Benzyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+6;
								end
				else			If A='Tr' then {Trityl}
								begin
									Point^.H:=Point^.H+12;
									Point^.C:=Point^.C+18;
								end
				else			If A='DMTr' then {Dimethoxytrityl}
								begin
									Point^.H:=Point^.H+16;
									Point^.C:=Point^.C+20;
									Point^.O:=Point^.O+2;
								end
				else			If A='Ts' then {Tosyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+2;
									Point^.S:=Point^.S+1;
								end
				else			If A='Ms' then {Mesyl}
								begin
									Point^.O:=Point^.O+2;
									Point^.S:=Point^.S+1;
								end
				else			If A='TMS' then {Trimethylsilyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+2;
									Point^.Si:=Point^.Si+1;
								end
				else			If A='TBDMS' then {Tert-butyldimethylsilyl}
								begin
									Point^.H:=Point^.H+12;
									Point^.C:=Point^.C+5;
									Point^.Si:=Point^.Si+1;
								end
				else			If A='TBDPS' then {Tert-butyldiphenylsilyl}
								begin
									Point^.H:=Point^.H+16;
									Point^.C:=Point^.C+15;
									Point^.Si:=Point^.Si+1;
								end
								
{O-R}				else			If A='OBz' then {O-Benzoyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+2;
								end
				else			If A='OAc' then {O-Acetyl}
								begin
									Point^.C:=Point^.C+1;
									Point^.O:=Point^.O+2;
								end
				else			If A='OMe' then {O-Methyl}
								begin
									Point^.H:=Point^.H+0;
									Point^.C:=Point^.C+0;
									Point^.O:=Point^.O+1;
								end
				else			If A='OEt' then {O-Ethyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='OPr' then {O-Propyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+2;
									Point^.O:=Point^.O+1;
								end
				else			If A='OBu' then {O-Butyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+3;
									Point^.O:=Point^.O+1;
								end
				else			If A='OiPr' then {O-2-Propyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+2;
									Point^.O:=Point^.O+1;
								end
				else			If A='OtBu' then {O-t-Butyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+3;
									Point^.O:=Point^.O+1;
								end
				else			If A='OBn' then {O-Benzyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+1;
								end
				else			If A='OTr' then {O-Trityl}
								begin
									Point^.H:=Point^.H+12;
									Point^.C:=Point^.C+18;
									Point^.O:=Point^.O+1;
								end
				else			If A='ODMTr' then {O-Dimethoxytrityl}
								begin
									Point^.H:=Point^.H+16;
									Point^.C:=Point^.C+20;
									Point^.O:=Point^.O+3;
								end
				else			If A='OTs' then {O-Tosyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+3;
									Point^.S:=Point^.S+1;
								end
				else			If A='OMs' then {O-Mesyl}
								begin
									Point^.O:=Point^.O+3;
									Point^.S:=Point^.S+1;
								end
				else			If A='OTMS' then {O-Trimethylsilyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+2;
									Point^.Si:=Point^.Si+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='OTBDMS' then {O-Tert-butyldimethylsilyl}
								begin
									Point^.H:=Point^.H+12;
									Point^.C:=Point^.C+5;
									Point^.Si:=Point^.Si+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='OTBDPS' then {O-Tert-butyldiphenylsilyl}
								begin
									Point^.H:=Point^.H+16;
									Point^.C:=Point^.C+15;
									Point^.Si:=Point^.Si+1;
									Point^.O:=Point^.O+1;
								end
{R-O}
				else			If A='BzO' then {O-Benzoyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+2;
								end
				else			If A='AcO' then {O-Acetyl}
								begin
									Point^.C:=Point^.C+1;
									Point^.O:=Point^.O+2;
								end
				else			If A='MeO' then {O-Methyl}
								begin
									Point^.H:=Point^.H+0;
									Point^.C:=Point^.C+0;
									Point^.O:=Point^.O+1;
								end
				else			If A='EtO' then {O-Ethyl}
								begin
									Point^.H:=Point^.H+2;
									Point^.C:=Point^.C+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='PrO' then {O-Propyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+2;
									Point^.O:=Point^.O+1;
								end
				else			If A='BuO' then {O-Butyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+3;
									Point^.O:=Point^.O+1;
								end
				else			If A='iPrO' then {O-2-Propyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+2;
									Point^.O:=Point^.O+1;
								end
				else			If A='tBuO' then {O-t-Butyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+3;
									Point^.O:=Point^.O+1;
								end
				else			If A='BnO' then {O-Benzyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+1;
								end
				else			If A='TrO' then {O-Trityl}
								begin
									Point^.H:=Point^.H+12;
									Point^.C:=Point^.C+18;
									Point^.O:=Point^.O+1;
								end
				else			If A='DMTrO' then {O-Dimethoxytrityl}
								begin
									Point^.H:=Point^.H+16;
									Point^.C:=Point^.C+20;
									Point^.O:=Point^.O+3;
								end
				else			If A='TsO' then {O-Tosyl}
								begin
									Point^.H:=Point^.H+4;
									Point^.C:=Point^.C+6;
									Point^.O:=Point^.O+3;
									Point^.S:=Point^.S+1;
								end
				else			If A='MsO' then {O-Mesyl}
								begin
									Point^.O:=Point^.O+3;
									Point^.S:=Point^.S+1;
								end
				else			If A='TMSO' then {O-Trimethylsilyl}
								begin
									Point^.H:=Point^.H+6;
									Point^.C:=Point^.C+2;
									Point^.Si:=Point^.Si+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='TBDMSO' then {O-Tert-butyldimethylsilyl}
								begin
									Point^.H:=Point^.H+12;
									Point^.C:=Point^.C+5;
									Point^.Si:=Point^.Si+1;
									Point^.O:=Point^.O+1;
								end
				else			If A='TBDPSO' then {O-Tert-butyldiphenylsilyl}
								begin
									Point^.H:=Point^.H+16;
									Point^.C:=Point^.C+15;
									Point^.Si:=Point^.Si+1;
									Point^.O:=Point^.O+1;
								end

								
				else
								begin
									Writeln('Unknown atom ',A, '- execution aborted');
									Halt(1); 
								end;
					end;
				Point:=Point^.Last;
		  end;
		Point:=Current;
		end;
	
	Close(IFile);
	if verbose then Writeln('---------------------- Summary -------------------------');
	While Point^.Last<>nil  do
		begin
			if verbose then Writeln('RecCount: ',Point^.RecCount,' X=',Point^.X,' Y=',Point^.Y,' C',Point^.C,' H',Point^.H,' N',Point^.N,' O',Point^.O,' P',Point^.P,' S',Point^.S,' Si',Point^.Si,' Br',Point^.Br,' Cl',Point^.Cl,' F',Point^.F,' I',Point^.I,' Na',Point^.Na,' K',Point^.K);
			C:=C+Point^.C;
			H:=H+Point^.H;
			N:=N+Point^.N;
			O:=O+Point^.O;
			P:=P+Point^.P;
			S:=S+Point^.S;
			Si:=Si+Point^.Si;
			Br:=Br+Point^.Br;
			Cl:=Cl+Point^.Cl;
			F:=F+Point^.F;
			I:=I+Point^.I;
			Na:=Na+Point^.Na;
			K:=K+Point^.K;

			Point:=Point^.Last;
		end;	
	If C>1 then Write('C',C);If C=1 then Write('C');
	If H>1 then Write('H',H);If H=1 then Write('H');
	If N>1 then Write('N',N);If N=1 then Write('N');
	If O>1 then Write('O',O);If O=1 then Write('O');
	If P>1 then Write('P',P);If P=1 then Write('P');
	If S>1 then Write('S',S);If S=1 then Write('S');
	If Si>1 then Write('Si',Si);If Si=1 then Write('Si');
	If Br>1 then Write('Br',Br);If Br=1 then Write('Br');
	If Cl>1 then Write('Cl',Cl);If Cl=1 then Write('Cl');
	If F>1 then Write('F',F);If F=1 then Write('F');
	If I>1 then Write('I',I);If I=1 then Write('I');
	If Na>1 then Write('Na',Na);If Na=1 then Write('Na');
	If K>1 then Write('K',K);If K=1 then Write('K');
	
	If exact then 
		begin
			M:=C*12+H*1.007825037+N*14.003074008+O*15.99491464+P*30.9737634+S*31.9720718+Si*27.9769284+Br*78.9183361+Cl*34.968852729+F*18.99840325+I*126.904477+Na*22.9897697+K*38.9637079;
			Writeln(' [',M:2:10,']');
		end
	else
		begin
			M:=C*12.011+H*1.0079+N*14.0067+O*15.9994+P*30.9738+S*32.064+Si*28.086+Br*79.90+Cl*35.453+F*18.9984+I*126.9045+Na*22.9898+K*39.10;
			Writeln(' [',M:2:3,']');
		end;
end.

